# weblib.Engine

import weblib
import string

class Engine:

    def __init__(self, script=None, pool=None, **kw):

        self.script = script       

        # first make sure they haven't passed us any bogus
        # keywords..
        
        acceptable = ["request", "response", "sess", "auth", "perm"]
        for item in kw.keys():
            if item not in acceptable:
                raise TypeError, "unexpected keyword argument: " + item

        # Any of the singletons can be turned off by passing
        # None, or customized by passing an instance..

        for item in acceptable:
            
            if kw.has_key(item):
                # use the one they supplied
                setattr(self, item, kw[item])
                
            elif item=="sess":
                self.sess = weblib.Sess(pool, engine=self)

            else:
                # use the default (eg, self.perm=weblib.Perm())
                setattr(self, item, weblib.__dict__[string.capitalize(item)](engine=self))
                        

    def run(self):
        import sys
        stdout = sys.stdout
        sys.stdout = self.response
        try:
            try:
                exec(self.script)
            except SystemExit:
                pass # don't really quit on response.end()                
        finally:
            sys.stdout = stdout

        #print self.response.buffer ## should this be in here, or the wrapper?




